Index: main/callerid.c
===================================================================
--- main/callerid.c	(revision 424965)
+++ main/callerid.c	(working copy)
@@ -1006,12 +1006,16 @@
 	return ast_is_valid_string(exten, "0123456789*#+()-.");
 }
 
-int ast_callerid_parse(char *instr, char **name, char **location)
+int ast_callerid_parse(char *input_str, char **name, char **location)
 {
-	char *ls, *le, *name_start;
+	char *ls, *le, *name_start, *instr;
+	int quotes_stripped = 0;
 
 	/* Handle surrounding quotes */
-	instr = ast_strip_quoted(instr, "\"", "\"");
+	instr = ast_strip_quoted(input_str, "\"", "\"");
+	if (instr != input_str) {
+		quotes_stripped = 1;
+	}
 
 	/* Try "name" <location> format or name <location> format or with a missing > */
 	if ((ls = strrchr(instr, '<'))) {
@@ -1027,7 +1031,7 @@
 
 		ast_copy_string(tmp, instr, sizeof(tmp));
 		ast_shrink_phone_number(tmp);
-		if (ast_isphonenumber(tmp)) {	/* Assume it's just a location */
+		if (!quotes_stripped && ast_isphonenumber(tmp)) {	/* Assume it's just a location */
 			name_start = NULL;
 			strcpy(instr, tmp); /* safe, because tmp will always be the same size or smaller than instr */
 			*location = instr;
Index: tests/test_callerid.c
===================================================================
--- tests/test_callerid.c	(revision 424965)
+++ tests/test_callerid.c	(working copy)
@@ -57,6 +57,7 @@
 		{"<number>", NULL, "number"},
 		{"name", "name", NULL},
 		{"\"name\"", "name", NULL},
+		{"\"*10\"", "*10", NULL},
 		{"\"name\" <>", "name", NULL},
 		{"name <>", "name", NULL},
 		{"1234", NULL, "1234"},
